#include <pspkernel.h>
#include <pspdisplay.h>
#include <pspdebug.h>
#include <pspgu.h>
#include <pspgum.h>
PSP_MODULE_INFO("gutest2", PSP_MODULE_USER, 1, 1);
static unsigned int __attribute__((aligned(16))) list[262144];
#define BUF_WIDTH (512)
#define SCR_WIDTH (480)
#define SCR_HEIGHT (272)

// 描画用Vertex構造体
typedef struct Vertex{
	float x, y, z;
}Vertex;
Vertex __attribute__((aligned(16))) point[1]; // ドットを打つため

// メインルーチン
int main() {
	pspDebugScreenInit();
	// gu設定一覧
	sceGuInit(); sceGuStart(GU_DIRECT, list); sceGuDrawBuffer(GU_PSM_8888, (void*)0, BUF_WIDTH);
	sceGuDispBuffer(SCR_WIDTH, SCR_HEIGHT, (void*)0x88000, BUF_WIDTH);
	sceGuDepthBuffer((void*)0x110000, BUF_WIDTH);
	sceGuOffset(2048 - (SCR_WIDTH/2), 2048 - (SCR_HEIGHT/2));
	sceGuViewport(2048, 2048, SCR_WIDTH, SCR_HEIGHT); sceGuScissor(0, 0, SCR_WIDTH, SCR_HEIGHT);
	sceGuEnable(GU_SCISSOR_TEST); sceGuFinish(); sceGuSync(0,0);
	sceDisplayWaitVblankStart(); sceGuDisplay(GU_TRUE);
	while(1){
		sceGuStart(GU_DIRECT,list); sceGuClearColor(0xFFFFFFFF); // 背景は白
		sceGuClear(GU_COLOR_BUFFER_BIT|GU_DEPTH_BUFFER_BIT);

		// ここからドット打ち
		point[0].x = 30.0f; // X座標を30に
		point[0].y = 20.0f; // Y座標を20に
		point[0].z = 0.0f; // Z座標は0をセット
		sceGuColor(0xFF000000);	// 描画色を黒色に指定
		// GU_POINTS(ドット)を、32bit/2D型で、頂点1つ、インデックスバッファ未指定、構造体point使用
		sceGuDrawArray(GU_POINTS, GU_VERTEX_32BITF|GU_TRANSFORM_2D, 1, 0, point);

		// ここまで
		sceGuFinish(); sceGuSync(0,0); sceDisplayWaitVblankStart(); sceGuSwapBuffers();
	}
	return 0;
}
